#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_create_tables.pl
#
#  This module invokes the dbamon_orastat module which is
#  included with DBAmon.
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$P = "dbamon_create_tables.pl";
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "$date ${P} | $msgmsg\n";
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub convertSQL
#------------------------------------------------------------------------------
{
  $tbl = $_[0];

  $file_in = "/opt/dbamon/sql_oracle/table_$tbl.sql"; 
  $file_out = "/opt/dbamon/sql_mssql/table_$tbl.sql"; 

  open(SQLOUT,">$file_out") || &error("Cannot open output $file_out - $!"); 
  open(TABLEDEF,$file_in) || &error("Cannot open input $file_in - $!"); 
  while(<TABLEDEF>)
  {
    $in_rec = $_; 

    #---- Editing
    # ts          date                      default sysdate
    if (/ date /) { $in_rec =~ s/ date / datetime2(0) /; }
    if (/ default sysdate/) { $in_rec =~ s/default sysdate/ default getdate()/; }

    $in_rec =~ s/tablespace dbamon_d//; 
    $in_rec =~ s/tablespace dbamon_x//; 
    $in_rec =~ s/varchar2/varchar/; 
    $in_rec =~ s/ clob / text /; 
    $in_rec =~ s/ number\(/ numeric\(/; 
    $in_rec =~ s/create index dbamon\./create index /; 
    $in_rec =~ s/create unique index dbamon\./create unique index /; 

    print SQLOUT $in_rec;
  }
  close(TABLEDEF); 
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------
 
$dir_out = "/opt/dbamon/sql_mssql"; 
mkdir $dir_out;

$dir_in = "/opt/dbamon/sql_oracle"; 
chdir("$dir_in");
opendir(IN_DIR, "$dir_in") || die "can't opendir $dir - $!";
@in_files = readdir IN_DIR;
foreach $file (@in_files)
{
  if ($file =~ /^table_/)
  {
    $z = length($file) - 10;
    $table = substr($file,6,$z);
    msg("Found table definition file=$file table=$table");
    &convertSQL("$table");
  }
}

&msg("Done");

exit 0;
